# -*- coding: utf-8 -*-
# Pokud si to kopírujete z okna prohlížeče a jste na windowsech tak změňte na prvním řádku "utf-8" na "windows-1250"
# Na začátku si založíme třídu obvod
class obvod:
	def __init__(self): # V podprogramu "__init__", který se spustí vždy při založení třídy nadefinujeme nějaké proměnné - parametry součástek obvodu a čas.
		self.t = 0 # Čas v sekundách od začátku. Dalo by se to představit jako takové hodiny programu. Budou potřeba u každé spojité simulace. Pokud děláme rozsáhlejší projekt (např. víc součástek), tak by bylo lepší počítat čas nějak centrálně, nám to ale takhle stačí.
		self.dt = 0.1 # Hodnota, která se přičte k času po každém vykonaném kroku (v sekundách, znač: Δt). (přičítání musíme taky zajistit) Pokud by tu nebyla, tak se sice kroky provádějí, ale čas na hodinách se nikam nepohne.
		self.r = 100 # Odpor (v ohmech, znač: R) našeho resistoru, v průběhu programu se měnit nebude.
		self.c = 10 # Kapacita kondenzatoru (ve faradech, znač: C). Kondenzátor si lze představit jako takovou "baterku", resistor zase jako žárovičku která svítí a tím baterku vybíjí (jeho odpor určuje jak moc ji vybíjí). Kapacita určuje kolik náboje je kondenzátor ("baterka") schopen pojmout, nebude se tedy měnit.
		self.q = 10.0 # Náboj kondenzátoru (v culombech, znač: Q). Nemůže být větší než jeho kapacita, protože určuje jak moc je kondenzátor aktuálně nabitý. Tato hodnota se bude postupně zmenšovat. Číslo je napsáno jako desetinné, abychom zajistili, že se výpočty nebudou zaokrouhlovat na celá čísla.

		# A tady je to všechno. Možná v těch vzorečcích vidíte další veličiny, ty si ale nechceme pamatovat, vypočteme si je v každém kroku (takže před sebou nebudou mít "self." - nechceme si je pamatovat do dalšího kroku).

	def krok(self): # Tento podprogram se bude pouštet stále dokola. Vždy si v něm spočítáme aktuální stav obvodu (jaké tam proudí proudy, napětí atd..) na konci pak upravíme čas (přičteme k němu Δt)
		u = self.q/self.c # Nejdřív vypočteme podle: U=Q/C aktuální napětí v obvodu (U).
		i = u/self.r # Pak pomocí napětí a vzorečku: I=U/R vypočítáme proud (I), kterým proudí elektrony v obvodu.
		dq = i * self.dt # Spočítáme o kolik se změnil náboj na kondenzátoru (ΔQ - dq) pomocí vzorečku ΔQ=I×Δt.
		self.q = self.q - dq # A nakonec vypočteme náboj, který nám zbývá na kondenzátrou a přiřádíme ho do proměnné self.q, protože si ho chceme pamatovat i dál, abychom od něj zas mohli něco odečíst v dalším kroku.
		print(self.q) # Úplně nakonec vypíšeme zbývající náboj
		self.t = self.t + self.dt # Nemsíme zapomenout na zvýšení aktuálního času o Δt, já to dělám na konci, aby v úplně prvním kroku byl čas 0.

# Třída by byla hotová, teď ji musíme ještě založit:
o = obvod()
# Musíme spouštět krok do doby, než náboj na kondenzátoru (Q) bude skoro nulový (nulový nebude nikdy), pak už se nebude skoro nic dít. Použijeme tedy cyklus while:
while (o.q > 0.01): # Dokud je náboj větší než 0.01
	o.krok() # tak spouštíme krok

print("Konec :-)")
